#include "DFRobot_WiFi_IoT_Module.h"
#include <SoftwareSerial.h>
#include <dht.h>
#include <OneWire.h>   //ds18b20
int DS18S20_Pin = 2; //DS18S20 Signal pin on digital 2
int button = 7;
#define  DHTPin 8
dht DHT;
OneWire ds(DS18S20_Pin);  // on digital pin 2

   //UART mode 
    //Use software serialport: D/R: 10, C/T: 11
    SoftwareSerial    mySerial(10, 11);
    DFRobot_WiFi_IoT_Module_UART IoT(&mySerial);
  
    //Configure WiFi name and password 
    const char *WIFI_SSID           = "AndroidAP";
    const char *WIFI_PASSWORD       = "djis4991";
    //Configure IFTTT
    const char *IFTTT_ADDRESS       = "maker.ifttt.com";
    const char *IFTTT_ENVENT        = "Notify";
    const char *IFTTT_KEY           = "b-szzeTz9-tS9D9X3bhZ_U";
    //IFTTT Send message 
    const char *IFTTT_VALUE_1       = "Value1";
    const char *IFTTT_VALUE_2       = "Value2";
    const char *IFTTT_VALUE_3       = "Value3";

float value1;
float value2;
float value3;
String msg;

float AllTemp(){
      float TemperatureSum = getTemp();
      int readData = DHT.read11(DHTPin); // DHT11
      value1 = DHT.temperature;
      value2 = DHT.humidity;
      value3 = (TemperatureSum);
      msg = "";
      msg = String(" ")+ String("DHT T:") + String(value1) + String(" DHT H:") + String(value2) + String(" Water T:") + String(value3);
      
      return msg;
}

    
void setup() {
      //Use software serialport 9600 as communication port 
      mySerial.begin(9600);
    
      //Use serialport 115200 as print port 
      Serial.begin(115200);
      //Init communication port 
      while(IoT.begin() != 0){  
        Serial.println("init ERROR!!!!");
        delay(100);
      }
      Serial.println("init Success");
      //Connect to WiFi
      while(IoT.connectWifi(WIFI_SSID, WIFI_PASSWORD) != 0){  
        Serial.print(".");
        delay(100);
      }
      Serial.println("Wifi Connect Success");
      //Init HTTP
      while(IoT.HTTPBegin(IFTTT_ADDRESS) != 0){
        Serial.println("Parameter is empty!");
        delay(100);
      }
      Serial.println("HTTP Configuration Succeeded");
      //Init IFTTT
      while(IoT.IFTTTBegin(IFTTT_ENVENT, IFTTT_KEY) != 0){
        Serial.println("Parameter is empty!");
        delay(100);
      }
      Serial.println("IFTTT Configuration Succeeded");
}


 float getTemp(){
  //returns the temperature from one DS18S20 in DEG Celsius

  byte data[12];
  byte addr[8];

  if ( !ds.search(addr)) {
      //no more sensors on chain, reset search
      ds.reset_search();
      return -1000;
  }

  if ( OneWire::crc8( addr, 7) != addr[7]) {
      Serial.println("CRC is not valid!");
      return -1000;
  }

  if ( addr[0] != 0x10 && addr[0] != 0x28) {
      Serial.print("Device is not recognized");
      return -1000;
  }

  ds.reset();
  ds.select(addr);
  ds.write(0x44,1); // start conversion, with parasite power on at the end

  byte present = ds.reset();
  ds.select(addr);
  ds.write(0xBE); // Read Scratchpad


  for (int i = 0; i < 9; i++) { // we need 9 bytes
    data[i] = ds.read();
  }

  ds.reset_search();

  byte MSB = data[1];
  byte LSB = data[0];

  float tempRead = ((MSB << 8) | LSB); //using two's compliment
  float TemperatureSum = tempRead / 16;

  return TemperatureSum;
}  

 void loop() {
      float TemperatureSum = getTemp();
      int readData = DHT.read11(DHTPin); // DHT11
      value1 = DHT.temperature;
      value2 = DHT.humidity;
      value3 = (TemperatureSum); 

      Serial.print("Values are ");
      Serial.println(value1);
      Serial.print(' ');
      Serial.print(value2);
      Serial.print(' ');
      Serial.print(value3);   // DS18
      Serial.print(' ');  
      
      
     
     
       if(digitalRead(7) == 1)
      {
        String data =String(AllTemp); 
        IoT.IFTTTSendMessage("reminder","The current data is",data.c_str());
        Serial.println("send message success!");
      }
  }
